// totally unclean experimental colection of bytes...

uniform samplerCube SkyBoxClouds;
uniform samplerCube SkyBoxSpace;
uniform vec3 uLight;                // odkud jde svetlo, zadavano programem
uniform mat4 SkyMatrix4x4_normal;   // lehke otaceni normal kvuli zpusobu nanaseni textury na skybox

varying vec4 vDiffuse;

void main(void)
{
  // par konstant, ktere by mozna bylo v budoucnu lepsi zadavat uniform promennou
  vec4 color_cloud    = vec4(0.9,   0.9,  1.0,  1.0);  // barva svetleho mraku
  vec4 color_sky_day  = vec4(0.65,  0.7,  1.0,  1.0);  // barva denni oblohy
  vec4 color          = vec4(0.0,   0.0,  0.0,  1.0);  // vysledna barva, pocatek je tmavey vesmir
  vec4 specular       = vec4(1.0,0.8,0.4,1.0); // gl_LightSource[0].specular;

  // nalezeni texelu z cube mapy a extrakce normaly a tloustky mraku v danem bode
  vec4  cube_clouds = textureCube(SkyBoxClouds, normalize(gl_TexCoord[0].xyz).xyz).rgba;
  vec3  cube_normal = normalize(cube_clouds.rgb*2.0-vec3(1.0, 1.0, 1.0));
  cube_normal=normalize((vec4(cube_normal, 0.0)*SkyMatrix4x4_normal).xyz);
  float thickness = cube_clouds.a;

  // zaijsteni uhlu svetla a faktoru jejich prispevku k barve
  vec3 tc=normalize(gl_TexCoord[0].xyz);
  float TCdotL = max(dot(tc,uLight), 0.0);
  float TCdotL_spec = clamp(dot(tc,uLight)+0.8, 0.0, 1.0);
  float NdotL = clamp(dot(cube_normal,uLight)+0.5, 0.0, 1.0);

  float backlight = 0.0;  // prosvetleni tencich mraku, kdyz je za nimi slunko
  float sidelight = 0.0;  // osvetleni zborku na zaklade normal mraku

  // samotne vypocty barvy a dalsi srandy kolem prusvitnosti mraku atd 
  if(TCdotL_spec > 0.0){
    // normalni osvetleni oblohy - modra / cerna barva
    color += vDiffuse * TCdotL_spec * color_sky_day;    
    
  }
  // normalova textura mraku - osvetluje jen kdyz na normaly sviti z boku
  if(NdotL > 0.0){
    sidelight = clamp((NdotL * (1.0-pow(TCdotL,0.5)) * clamp(TCdotL_spec+0.5,0.0,1.0) - thickness*0.1), 0.0, 1.0);
  }
  
  // vypocet prusvitnosti mraku a jasnost skunka
  if(TCdotL > 0.0){
    float t = pow(1.0-thickness, 2.0);
    backlight = -cos(t*6.2832)/2.0+0.5;
    backlight *= 0.5*(pow(TCdotL,1.0) + pow(TCdotL,10.0)*(1.0+(1.0-vDiffuse.r)*10.0));
    
    color += specular*pow(TCdotL, 1000.0); // slunicko XXX bacha na vysoke mocniny! nekde mozna nepojede uplne OK
  }

  // mixovani barvy mraku bez osvetleni s osvetlenim
  //float light=mix(backlight, sidelight, 0.5);
  float light=max(backlight, sidelight);
  vec4 cloud = mix(vDiffuse,
                   vec4(1.0,1.0,1.0,1.0),
                   1.0-TCdotL_spec) *
               clamp(TCdotL_spec-thickness/4.0+0.2,0.0,1.0) * 0.8;
  cloud += color_cloud * specular * light * 0.8;

  // pridani hvezd - ridi se mnozstvim modre barvy v barve oblohy
  color += textureCube(SkyBoxSpace, normalize(gl_TexCoord[0].xyz))*(1.0-clamp(color.b*2.0,0.0,1.0));
  
  // prekryti barvy oblohy (vzduchu, hvezd a slunka) mrakama
  color = mix(color, cloud, 
              clamp(pow(thickness/2.0+1.0,4.0)-1.0, 0.0, 1.0));
  color.a=1.0;
  gl_FragColor=color;
}
