// totally unclean experimental colection of bytes...
/* dodelat: scale, svetlost, paralax, stiny*/

uniform float ScaleX;
uniform float ScaleY;
uniform float ScaleZ;

uniform sampler3D Noise1;
uniform sampler2D TexMain;
uniform sampler2D TexDetail;
uniform sampler1D TexHeight;

uniform sampler2DShadow TexShadow;
uniform float uTexShadowSize;
uniform int   uShowShadows;
varying vec4  vTexCoordShadow;

varying vec3 vNormal;
varying vec3 vLight;
varying vec3 vHalfVec;
varying vec4 vDiffuse, vAmbient;
varying vec3 vPos;

varying float vFogFactor;

// Performs 4-sample percentage closer filtering (PCF)
float pcf (vec3 shadow_coord)
{
	float resolution = 1.0 / uTexShadowSize;	// size of a texel in texture coordinates
	
	// locate lowerleft-texel location
	vec2 texel_coord = max(shadow_coord.st * uTexShadowSize - 0.5, 0.0);
	vec3 lltexel = vec3((floor(texel_coord) + 0.5) * resolution, shadow_coord.p);
	
	// take 4 samples
	float sample1 = shadow2D(TexShadow, lltexel).x,
	      sample2 = shadow2D(TexShadow, lltexel + vec3(resolution, 0.0, 0.0)).x,
	      sample3 = shadow2D(TexShadow, lltexel + vec3(0.0, resolution, 0.0)).x,
	      sample4 = shadow2D(TexShadow, lltexel + vec3(resolution, resolution, 0.0)).x;
	
	// take a weighted average of them, using bilinear filtering
	vec2 factor = fract(texel_coord);
	return (1.0-factor.t) * ((1.0-factor.s) * sample1 + factor.s * sample2) +
	       factor.t       * ((1.0-factor.s) * sample3 + factor.s * sample4);
}


void main(void)
{
  vec3 n,halfV;
  float NdotL,NdotHV;
  
  // uprava normaly pro bumpmaping
  vec4 noisy1 = texture3D(Noise1,vec3(vPos.x*0.043,vPos.y*0.043,0.0)).rgba*2.0-1.0;
  vec4 noisy2 = texture3D(Noise1,vec3(vPos.x*0.27,vPos.y*0.27,0.0)).rgba*2.0-1.0;

  // barvy z textur
  vec4 tex0=texture2D(TexDetail,vPos.xy);
  vec4 tex1=texture2D(TexMain,vec2(vPos.x/ScaleX,vPos.y/ScaleY));
  vec4 tex2=texture1D(TexHeight,vPos.z/ScaleZ+noisy1.w/50.0);

  vec3 noisy=mix(normalize(noisy1.rgb),normalize(noisy2.rgb),0.3);
  noisy.z=0.0;
  float noise_mul=0.5;
  n = normalize(gl_NormalMatrix*normalize(vNormal+noisy.xyz*noise_mul));
  //n = normalize(gl_NormalMatrix*normalize(vNormal));

  // osvetleni
  vec4 color = vAmbient;          // zakladni slozka vsudypritomneho svetla
  //NdotL = pow(max(dot(n,vLight),0.0)*1.5,1.5);
  NdotL = max(dot(n,vLight),0.0);

	// Determine if this fragment is within the area affected by the shadow map
	float shadow = 1.0;
	//shadow=shadow2DProj(TexShadow,vTexCoordShadow).r;
	vec4 shadow_coord = vTexCoordShadow;
	if(uShowShadows==1 && abs(shadow_coord.s) < abs(shadow_coord.q) &&
		abs(shadow_coord.t) < abs(shadow_coord.q) &&
		shadow_coord.p > 0.0)
	{
		// Perform homogenous divide
		shadow_coord /= shadow_coord.q;
		// Map from NDC to viewport
		shadow_coord.stp = shadow_coord.stp;
		// Lookup shadow value
		shadow = pcf(shadow_coord.stp);
	}

  if (NdotL > 0.0) {
    vec4 color_l = vDiffuse * NdotL;    // normalni osvetleni
    
    halfV = normalize(vHalfVec);  // zbytek pridava odlesky
    NdotHV = max(dot(n,halfV),0.0);
    //NdotHV=pow(NdotHV,10.0);
    color_l += gl_FrontMaterial.specular * gl_LightSource[0].specular * pow(NdotHV, gl_FrontMaterial.shininess);
    
    color+=color_l*shadow;
  }

  // zapis vysledku
  // samotna barva
  gl_FragColor=tex0*tex1*tex2; 

  // svetlo
  gl_FragColor*=color;

  // "mlha" - hloubka vody
  //gl_FragColor=mix(gl_FragColor,vFogColor,vFogFactor);
  gl_FragColor=mix(gl_FragColor,mix(gl_Fog.color,gl_Fog.color*0.5,vFogFactor),vFogFactor);
  gl_FragColor.a=1.0;

//  float tmp = texture3D(Noise1,vec3(vPos.x*0.043,vPos.y*0.043,0.0)).a;
//  gl_FragColor=vec4(tmp,tmp,tmp,1.0);
}
